//+------------------------------------------------------------------+
//|                                                       Edding.mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_level1 1
#property indicator_level2 0
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 Green
#property indicator_color4 DarkViolet
#property indicator_color5 Orange
//---- input parameters
extern string    jmm=" // JMA // ";
extern int       period_jma_a=6;  //  1-  JMA 
extern int       period_jma_b=3;  //  2-  JMA
extern int       sg_a=5;          //    JMA,    -100 ... +100, 
                                  //    ;
extern int       sg_b=5;          //    JMA,    -100 ... +100, 
                                  //    ;
extern int       shift=0;         //   n - 
extern int       price_jma=4;     //  0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED.
extern string    mma=" // MA //";
extern int       period_ma=48;   //  MA
extern int       method_ma=1;    //   MA 
extern int       price_ma=4;     //  MA  0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED.

extern double    kf=0.01;         //   MA
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM,EMPTY,4,Blue);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_HISTOGRAM,EMPTY,4,Red);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(2,DRAW_HISTOGRAM,EMPTY,2,Green);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexStyle(3,DRAW_HISTOGRAM,EMPTY,2,DarkViolet);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexStyle(4,DRAW_HISTOGRAM,EMPTY,4,Orange);
   SetIndexBuffer(4,ExtMapBuffer5);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   int    i=Bars-counted_bars-1;
   while(i>=0){ 
//----
 double JMA=iCustom(NULL,0,"J2JMA",period_jma_a,period_jma_b,sg_a,sg_b,shift,price_jma,0,i);
 double JMA_p=iCustom(NULL,0,"J2JMA",period_jma_a,period_jma_b,sg_a,sg_b,shift,price_jma,0,i+1);
 double MA=iMA(NULL,0,period_ma,0,method_ma,price_ma,i); 
 double MA_p=iMA(NULL,0,period_ma,0,method_ma,price_ma,i+1);
 
 if(JMA>MA && JMA>JMA_p && MA>(MA_p+(kf*MA_p)/100) ){
 ExtMapBuffer1[i]=1.0;ExtMapBuffer2[i]=0.0;ExtMapBuffer3[i]=0.0;ExtMapBuffer4[i]=0.0;ExtMapBuffer5[i]=0.0; 
 
 }else{//else1
 
 if(JMA>MA && JMA<JMA_p && MA>(MA_p+(kf*MA_p)/100) ){ExtMapBuffer3[i]=1.0;ExtMapBuffer1[i]=0.0;ExtMapBuffer2[i]=0.0;ExtMapBuffer4[i]=0.0;ExtMapBuffer5[i]=0.0;
 
 }else{
 
 if(JMA<MA && JMA<JMA_p && MA<(MA_p-(kf*MA_p)/100) ){ExtMapBuffer2[i]=1.0;ExtMapBuffer1[i]=0.0;ExtMapBuffer3[i]=0.0;ExtMapBuffer4[i]=0.0;ExtMapBuffer5[i]=0.0;
 }else{if(JMA<MA && JMA>JMA_p && MA<(MA_p-(kf*MA_p)/100) ){ExtMapBuffer4[i]=1.0;ExtMapBuffer1[i]=0.0;ExtMapBuffer2[i]=0.0;ExtMapBuffer3[i]=0.0;ExtMapBuffer5[i]=0.0;
 }else{ExtMapBuffer5[i]=1.0;ExtMapBuffer1[i]=0.0;ExtMapBuffer2[i]=0.0;ExtMapBuffer3[i]=0.0;ExtMapBuffer4[i]=0.0;}}} 
 
}//else1
//----
i--;
}
   return(0);
  }
//+------------------------------------------------------------------+